#!/usr/local/bin/perl 

use strict;
use MyBench;
use Getopt::Long;
use Time::HiRes qw(gettimeofday tv_interval);
use DBI;

my($num_kids, $num_runs) = @ARGV;
$num_kids ||= 10; $num_runs ||= 1000;

my $callback = sub {
    my $id  = shift;
    my $dbh = DBI->connect('dbi:mysql:test', 'root', '', { RaiseError => 1 });
    my $sth = $dbh->prepare("SELECT * FROM mytable WHERE id = ?");

    my $cnt = 0;
    my @times = ();

    # ƥץ HUP ʥäƤޤԵޤ
    local $SIG{HUP} = sub { };
    sleep 600;

    while ($cnt < $num_runs) {
        my $v = int(rand(100_000));
        my $t0 = [gettimeofday];
        $sth->execute($v);
        my $t1 = tv_interval($t0, [gettimeofday]);
        push @times, $t1;
        $sth->finish();
        $cnt++;
    }

    $dbh->disconnect();
    my @r = ($id, scalar(@times), min(@times), max(@times), avg(@times), tot(@times));
    return @r;
};

my @results = MyBench::fork_and_work($num_kids, $callback);
MyBench::compute_results('test', @results);

exit;



